using System.Collections.Generic;
using System.Linq;
using MacGruber;
using SimpleJSON;
using UnityEngine;

namespace CheesyFX
{
    public class Anus : Orifice
	{
		public JSONStorableBool twinkEnabled = new JSONStorableBool("Twinking Enabled", true);

		// public JSONStorableFloat stretchToGapeFactor = new JSONStorableFloat("Stretch To Gape Factor", 17.5f, 0f, 25f, false, true);
		public JSONStorableFloat gapeRegressionSpeed = new JSONStorableFloat("Gape Regression", .5f, 0f, 3f, false, true);
		// public JSONStorableFloat cycleRatio1 = CheesyUtils.SetupJSONFloat("Gape CycleRatio 1", .25f, 0f, 1f, true, true);
		// public JSONStorableFloat cycleRatio2 = CheesyUtils.SetupJSONFloat("Gape CycleRatio 2", .5f, 0f, 1f, true, true);
		public JSONStorableFloat twinkInterval_mean = new JSONStorableFloat("Twink Interval Mean", 1.5f, .5f, 10f, true, true);
		public JSONStorableFloat twinkInterval_delta = new JSONStorableFloat("Twink Interval Delta", 1.2f, 0f, 1.35f, true, true);
		
		public JSONStorableFloat gapeMorph;
		public JSONStorableFloat relaxationGainJSON = new JSONStorableFloat("Relaxation Gain", 10f, 0f, 100f, false);
		public JSONStorableFloat relaxationRegressionJSON = new JSONStorableFloat("Relaxation Regression", 20f, 0f, 100f, false);
		public JSONStorableFloat gapeScale = new JSONStorableFloat("Gape Scale", 1f, 0f, 1f);

		private float relaxationGain;
		private float relaxationRegression;
		float nextTwinkTime;
		private Transform _stretchRef;
		private float _baseStretch = .012f;
		private float _stretch;
		private float twinkMeanDeltaPercentage = .8f;

		// List<Collider> abdomen;

		public override void Init(string name){
			relaxation = new JSONStorableFloat("Relaxation", .1f, .1f, 5f, true, false);
			base.Init(name);
			DAZCharacterSelector characterSelector = FillMeUp.atom.GetStorableByID("geometry") as DAZCharacterSelector;
			GenerateDAZMorphsControlUI morphControl = characterSelector.morphsControlUI;
			// foreach(var s in morphControl.GetMorphUids()){
			// 	if(s.Contains("Belly Bulger")) s.Print();
			// }

			_stretchRef = FillMeUp.atom.rigidbodies.First(x => x.name == "_JointAr").transform;
			depthReference = FillMeUp.atom.rigidbodies.First(x => x.name == "abdomen");
			
			relaxationGain = relaxationGainJSON.defaultVal * .001f;
			relaxationRegression = relaxationRegressionJSON.defaultVal * .001f;

			twinkInterval_mean.setCallbackFunction += val =>
			{
				twinkInterval_delta.constrained = false;
				twinkInterval_delta.valNoCallback = twinkMeanDeltaPercentage * val;
				twinkInterval_delta.max = .9f * val;
				twinkInterval_delta.constrained = true;
			};

			twinkInterval_delta.setCallbackFunction += val => twinkMeanDeltaPercentage = val / twinkInterval_mean.val;

			enabledJ.setCallbackFunction = x => Reset();
			relaxationGainJSON.setCallbackFunction += val => relaxationGain = val * .001f;
			relaxationRegressionJSON.setCallbackFunction += val => relaxationRegression = val * .001f;

			string gapeMorphPath = "Custom/Atom/Person/Morphs/female_genitalia/CheesyFX/BodyLanguage/BL_Gape.vmi";
			string packageUid = Utils.GetPackagePath(FillMeUp.singleton);
			if (packageUid != string.Empty) gapeMorphPath = packageUid + gapeMorphPath;
			gapeMorph = morphControl.GetMorphByUid(gapeMorphPath).jsonFloat;
			gapeMorph.val = 0f;
			gapeMorph.constrained = false;

			nextTwinkTime = twinkInterval_mean.val;
			name = "Anus";
			
			// triggerHolder.createItemUI = x =>
			// {
			// 	triggerHolder.CreateToggle(x);
			// 	triggerHolder.CreateConfigure(x);
			// };
			// bodyRegionManager.atom.rigidbodies.ToList().ForEach(x => {if(x.name.Contains("abdomen")) x.name.Print();});
		}

		public override void GetStretch()
		{
			_stretch = _stretchRef.localPosition.x - _baseStretch;
		}

		public void StimulateAnus(Collision collision, float stimulus)
		{
		}

		public override float Stimulate(float scale)
		{
			float stimulus = base.Stimulate(scale);
			if(enabledJ.val){
				stretch.val += stimulus * relaxation.val * .01f;
				relaxation.val += stimulus * relaxationGain;
			}

			return stimulus;
		}

		private float currentStretch;
		private bool currentStretchSet;
		private float gapeTimer;
		private float totalTwinkTime;
		private float closeTime;
		private float a1;
		private float a2;
		
		public override void FixedUpdate(){
			if(enabledJ.val)
			{
				base.FixedUpdate();
				if (isPenetrated)
				{
					stretch.max = Mathf.Lerp(stretch.max, _stretch * 17.5f, Time.fixedDeltaTime);
					gapeMorph.val = stretch.val;
					if (currentStretchSet)
					{
						currentStretchSet = false;
						gapeTimer = 0f;
					}
				}
				else
				{
					if (!currentStretchSet)
					{
						currentStretch = stretch.val;
						nextTwinkTime = 0f;
						totalTwinkTime = 0f;
						currentStretchSet = true;
					}
					gapeTimer += Time.deltaTime;
					// relaxation.val -= .0005f;
					relaxation.val = Mathf.Lerp(relaxation.val, 0f, relaxationRegression * Time.fixedDeltaTime);
					if (gapeScale.val == 0f)
					{
						gapeMorph.val = 0f;
						return;
					}
					if(stretch.val > .001f)
					{
						stretch.val = gapeScale.val * currentStretch * (2f - Mathf.Pow(1f+gapeRegressionSpeed.val, gapeTimer / relaxation.val));
						if(twinkEnabled.val)
						{
							nextTwinkTime -= Time.fixedDeltaTime;
							if(nextTwinkTime <= 0f)
							{
								nextTwinkTime = NormalDistribution.GetValue(twinkInterval_mean.val, twinkInterval_delta.val, useNormalD : false);
								totalTwinkTime = nextTwinkTime * Random.Range(.4f, .6f);
								closeTime = totalTwinkTime * Random.Range(.4f, .6f);
								a1 = Mathf.Pow(2f, 1f / closeTime);
								a2 = Mathf.Pow(.001f, -1f / (totalTwinkTime - closeTime));
							}
							if(nextTwinkTime <= totalTwinkTime)
							{
								var t = totalTwinkTime - nextTwinkTime;
								if(t < closeTime) gapeMorph.val = stretch.val * (2f - Mathf.Pow(a1, t));
								else gapeMorph.val = stretch.val * (1f - Mathf.Pow(a2, closeTime-t));
							}
							else gapeMorph.val = stretch.val;
						}
						else gapeMorph.val = stretch.val;	
					}
					else{
						if(gapeMorph.val != 0f) gapeMorph.val = 0f;
						if(stretch.val != 0f) stretch.val = 0f;
					}
				}
				
			}	
		}

		public void Reset(){
			stretch.val = 0f;
			gapeMorph.val = 0f;
			depth.val = 0f;
			depthMeter.transform.parent = null;
		}

		public void ResetTwink(){
			nextTwinkTime = -1f;
			// gape.val = stimulation.val;
		}

		public override void CreateTriggersUI()
		{
			// enabledJ.CreateUI(UIElements);
			twinkEnabled.CreateUI(UIElements, true);
			base.CreateTriggersUI();;
			// relaxation.CreateUI(UIElements, true);
			gapeScale.CreateUI(UIElements, true);
			gapeRegressionSpeed.CreateUI(UIElements, true);
			var uid = (UIDynamicSlider) relaxationGainJSON.CreateUI(UIElements, true);
			uid.valueFormat = "0.000";
			gapeScale.CreateUI(UIElements);
			uid = (UIDynamicSlider) relaxationRegressionJSON.CreateUI(UIElements, true);
			uid.valueFormat = "0.000";
			twinkInterval_mean.CreateUI(UIElements, true);
			twinkInterval_delta.CreateUI(UIElements, true);
		}
		
		public override void CreateBulgeSettingsUI()
		{
			bulgeScale.CreateUI(UIElements);
			bulgeSharpness.CreateUI(UIElements, true);
			bulgeDepthScale.CreateUI(UIElements);
		}

		public override JSONClass Store(string subScenePrefix, bool storeTriggers = true)
		{
			JSONClass jc = base.Store(subScenePrefix, storeTriggers);
			gapeScale.Store(jc);
			gapeRegressionSpeed.Store(jc);
			relaxationGainJSON.Store(jc);
			relaxationRegressionJSON.Store(jc);
			twinkInterval_mean.Store(jc);
			twinkInterval_delta.Store(jc);
			return jc;
		}

		public override void Load(JSONClass jc, string subScenePrefix)
		{
			base.Load(jc, subScenePrefix);
			if(jc.HasKey(name))
			{
				JSONClass tc = jc[name].AsObject;
				gapeScale.Load(tc);
				gapeRegressionSpeed.Load(tc);
				relaxationGainJSON.Load(tc);
				relaxationRegressionJSON.Load(tc);
				twinkInterval_mean.Load(tc);
				twinkInterval_delta.Load(tc);
			}
		}
	}
}