using UnityEngine;

namespace CheesyFX
{
    public class TriggerHandler : MonoBehaviour
    {
        public bool isActive;
        public Orifice orifice;
        public Collider lastCollider;
        private int numCollisions;
		
        public void OnTriggerEnter(Collider collider){
            if (collider.isTrigger) return;
            numCollisions++;
            lastCollider = collider;
            orifice.Stimulate(.05f);
            // orifice.name.Print();
            if (!orifice.isPenetrated)
            {
                // orifice.name.Print();
                // collider.name.Print();
                orifice.isPenetrated = true;
                orifice.penetratingAtom = collider.attachedRigidbody.GetAtom();
                orifice.RegisterCollision(collider);
                if (FillMeUp.visualizeDepth.val) orifice.depthMeterRenderer.enabled = true;
                orifice.onEnterActions?.Invoke();
            }
        }
		
        public void OnTriggerExit(Collider collider)
        {
            if (collider.isTrigger) return;
            numCollisions--;
            if (numCollisions == 0)
            {
                orifice.isPenetrated = false;
                orifice.penetratingAtom = null;
                if (FillMeUp.visualizeDepth.val) orifice.depthMeterRenderer.enabled = false;
                orifice.onExitActions?.Invoke();
            }
        }

        public void Reset()
        {
            numCollisions = 0;
            orifice.isPenetrated = false;
        }
    }
}